> ## Documentation Index
> Fetch the complete documentation index at: https://developers.avacloud.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List subnets

> Lists all subnets registered on the network.



## OpenAPI

````yaml get /v1/networks/{network}/subnets
openapi: 3.1.0
info:
  title: Data API
  description: >-
    The Data API provides web3 application developers with multi-chain data
    related to Avalanche's primary network, Avalanche subnets, and Ethereum.
    With Data API, you can easily build products that leverage real-time and
    historical transaction and transfer history, native and token balances, and
    various types of token metadata. The API is in Beta and may be subject to
    change.</br></br>If you have feedback or feature requests for the API,
    please submit them <a
    href="https://portal.productboard.com/dndv9ahlkdfye4opdm8ksafi/tabs/4-glacier-api">here</a>.
    Bug reports can be submitted <a
    href="https://docs.google.com/forms/d/e/1FAIpQLSeJQrcp7QoNiqozMDKrVJGX5wpU827d3cVTgF8qa7t_J1Pb-g/viewform">here</a>,
    and any potential security issues can be reported <a
    href="https://immunefi.com/bounty/avalabs">here</a>.
  version: 1.0.0
  contact: {}
servers:
  - url: https://glacier-api.avax.network
security:
  - apiKey: []
  - {}
tags:
  - name: EVM Chains
    description: >-
      Find information about indexed EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Blocks
    description: >-
      Find information about blocks on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Transactions
    description: >-
      Find information about transactions on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Balances
    description: >-
      Find information about balances on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Contracts
    description: >-
      Find information about contracts on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: Primary Network
  - name: Primary Network Blocks
    description: >-
      Find information about blocks on Avalanche's Primary Network Chains - the
      P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Vertices
    description: Find information about vertices on Avalanche's X-Chain.
  - name: Primary Network Transactions
    description: >-
      Find information about transactions on Avalanche's Primary Network Chains
      - the P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Balances
    description: >-
      Find information about balances on Avalanche's Primary Network Chains -
      the P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network UTXOs
    description: >-
      Find information about utxos on Avalanche's Primary Network Chains - the
      P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Rewards
    description: Find information about rewards on Avalanche's Primary Network.
  - name: NFTs
  - name: Operations
  - name: Health Check
  - name: Teleporter
    description: Find information about Teleporter transactions.
  - name: Interchain Messaging
    description: Find information about Interchain Messaging transactions.
  - name: Webhooks
    description: Manage webhooks and get notified for various onchain activities.
  - name: RPC
    description: Interact with chain nodes using JSON-RPC.
  - name: Data API Usage Metrics
    description: Usage metrics and logs for the Data API.
  - name: Signature Aggregator
    description: Request signatures for a Warp message from Subnet validators
  - name: Notifications
    description: Get notifications for validator status and activity issues.
  - name: AVAX Supply
    description: Find information about AVAX supply.
paths:
  /v1/networks/{network}/subnets:
    get:
      tags:
        - Primary Network
      summary: List subnets
      description: Lists all subnets registered on the network.
      operationId: listSubnets
      parameters:
        - name: pageToken
          required: false
          in: query
          description: >-
            A page token, received from a previous list call. Provide this to
            retrieve the subsequent page.
          schema:
            type: string
        - name: pageSize
          required: false
          in: query
          description: >-
            The maximum number of items to return. The minimum page size is 1.
            The maximum pageSize is 10000.
          schema:
            type: integer
            default: 100
            minimum: 1
            maximum: 10000
          example: '10'
        - name: network
          required: true
          in: path
          description: Either mainnet or testnet/fuji.
          example: mainnet
          schema:
            $ref: '#/components/schemas/Network'
        - name: sortOrder
          required: false
          in: query
          example: asc
          description: >-
            The order by which to sort results. Use "asc" for ascending order,
            "desc" for descending order. Sorted by timestamp or the `sortBy`
            query parameter, if provided.
          schema:
            $ref: '#/components/schemas/SortOrder'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListSubnetsResponse'
        '400':
          description: |-
            Bad requests generally mean the client has passed invalid 
                or malformed parameters. Error messages in the response could help in 
                evaluating the error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
        '401':
          description: |-
            When a client attempts to access resources that require 
                authorization credentials but the client lacks proper authentication 
                in the request, the server responds with 401.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Unauthorized'
        '403':
          description: |-
            When a client attempts to access resources with valid
                credentials but doesn't have the privilege to perform that action, 
                the server responds with 403.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Forbidden'
        '404':
          description: |-
            The error is mostly returned when the client requests
                with either mistyped URL, or the passed resource is moved or deleted, 
                or the resource doesn't exist.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFound'
        '429':
          description: |-
            This error is returned when the client has sent too many,
                and has hit the rate limit.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TooManyRequests'
        '500':
          description: |-
            The error is a generic server side error that is 
                returned for any uncaught and unexpected issues on the server side. 
                This should be very rare, and you may reach out to us if the problem 
                persists for a longer duration.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InternalServerError'
        '502':
          description: |-
            This is an internal error indicating invalid response 
                  received by the client-facing proxy or gateway from the upstream server.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadGateway'
        '503':
          description: |-
            The error is returned for certain routes on a particular
                Subnet. This indicates an internal problem with our Subnet node, and may 
                not necessarily mean the Subnet is down or affected.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ServiceUnavailable'
      x-codeSamples:
        - lang: javascript
          label: JavaScript
          source: |-
            import { Avalanche } from "@avalanche-sdk/chainkit";

            const avalanche = new Avalanche({
              network: "mainnet",
            });

            async function run() {
              const result = await avalanche.data.primaryNetwork.listSubnets({
                pageSize: 10,
                sortOrder: "asc",
              });

              for await (const page of result) {
                console.log(page);
              }
            }

            run();
components:
  schemas:
    Network:
      type: string
      enum:
        - mainnet
        - fuji
        - testnet
    SortOrder:
      type: string
      enum:
        - asc
        - desc
    ListSubnetsResponse:
      type: object
      properties:
        nextPageToken:
          type: string
          description: >-
            A token, which can be sent as `pageToken` to retrieve the next page.
            If this field is omitted or empty, there are no subsequent pages.
        subnets:
          type: array
          items:
            $ref: '#/components/schemas/Subnet'
      required:
        - subnets
    BadRequest:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 400
        error:
          type: string
          description: The type of error
          examples:
            - Bad Request
      required:
        - message
        - statusCode
        - error
    Unauthorized:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 401
        error:
          type: string
          description: The type of error
          examples:
            - Unauthorized
      required:
        - message
        - statusCode
        - error
    Forbidden:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 403
        error:
          type: string
          description: The type of error
          examples:
            - Forbidden
      required:
        - message
        - statusCode
        - error
    NotFound:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 404
        error:
          type: string
          description: The type of error
          examples:
            - Not Found
      required:
        - message
        - statusCode
        - error
    TooManyRequests:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 429
        error:
          type: string
          description: The type of error
          examples:
            - Too Many Requests
      required:
        - message
        - statusCode
        - error
    InternalServerError:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 500
        error:
          type: string
          description: The type of error
          examples:
            - Internal Server Error
      required:
        - message
        - statusCode
        - error
    BadGateway:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 502
        error:
          type: string
          description: The type of error
          examples:
            - Bad Gateway
      required:
        - message
        - statusCode
        - error
    ServiceUnavailable:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 503
        error:
          type: string
          description: The type of error
          examples:
            - Service Unavailable
      required:
        - message
        - statusCode
        - error
    Subnet:
      type: object
      properties:
        createBlockTimestamp:
          type: number
        createBlockIndex:
          type: string
        subnetId:
          type: string
        ownerAddresses:
          deprecated: true
          description: This field is deprecated. Use subnetOwnershipInfo instead.
          type: array
          items:
            type: string
        threshold:
          type: number
          deprecated: true
          description: This field is deprecated. Use subnetOwnershipInfo instead.
        locktime:
          type: number
          deprecated: true
          description: This field is deprecated. Use subnetOwnershipInfo instead.
        subnetOwnershipInfo:
          description: Latest subnet owner details for this Subnet.
          allOf:
            - $ref: '#/components/schemas/SubnetOwnershipInfo'
        isL1:
          type: boolean
          description: Whether the subnet is an L1 or not.
        l1ConversionTransactionHash:
          type: string
          description: >-
            Transaction hash of ConvertSubnetToL1Tx which converted this Subnet
            to L1.
        l1ValidatorManagerDetails:
          description: L1 validator manager details.
          allOf:
            - $ref: '#/components/schemas/L1ValidatorManagerDetails'
        blockchains:
          type: array
          items:
            $ref: '#/components/schemas/Blockchain'
      required:
        - createBlockTimestamp
        - createBlockIndex
        - subnetId
        - ownerAddresses
        - threshold
        - locktime
        - subnetOwnershipInfo
        - isL1
        - blockchains
    SubnetOwnershipInfo:
      type: object
      properties:
        locktime:
          type: number
          description: >-
            Locktime in seconds after which Subnet owners can control this
            Subnet.
          examples:
            - 0
        threshold:
          type: number
          description: >-
            Minimum number of signatures required to sign the Subnet update
            transactions.
          examples:
            - 1
        addresses:
          description: Addresses that are eligible to sign the Subnet update transactions.
          examples:
            - - avax1qm2a25eytsrj235hxg6jc0mwk99tss64eqevsw
          type: array
          items:
            type: string
      required:
        - locktime
        - threshold
        - addresses
    L1ValidatorManagerDetails:
      type: object
      properties:
        blockchainId:
          type: string
        contractAddress:
          type: string
      required:
        - blockchainId
        - contractAddress
    Blockchain:
      type: object
      properties:
        createBlockTimestamp:
          type: number
        createBlockNumber:
          type: string
        blockchainId:
          type: string
        vmId:
          type: string
        subnetId:
          type: string
        blockchainName:
          type: string
        evmChainId:
          type: number
          description: >-
            EVM Chain ID for the EVM-based chains. This field is extracted from
            genesis data, and may be present for non-EVM chains as well.
          example: 43114
        genesisData:
          type: object
          description: The genesis data of the blockchain.
          example: '{"chainId": 43114}'
      required:
        - createBlockTimestamp
        - createBlockNumber
        - blockchainId
        - vmId
        - subnetId
        - blockchainName
        - evmChainId
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: x-glacier-api-key
      description: >-
        Api keys provide higher access to rate limits. To obtain an api key,
        sign up for an account at https://avacloud.io/.

````